#!/usr/bin/perl
#initialize hashtables
use IO::Socket;
use IO::Select;
use Time::HiRes qw (usleep);
use Term::ReadKey;

%login = ( );
%opers = ( );
%events = ( );
%hooks = ( );
%rawhooks = ( );
%modestr = ( );
%chanacc = ( );
%params = ( );
%chmembers = ( );
%chusrcnt = ( );
%eventExec = ( );
%signals = ( );
%remote = ( );
%listeners = ( );
%users = ( );
%usercnts = ( );
%blacklist = ( );
%onchan = ( );
%channels = ( );
%gecos = ( );
%punishments = ( );

$select = IO::Select->new();


require("./console.pl") or die ("Couldn't load console engine.");
require("./events.pl") or die ("Couldn't load events engine.");
require("./config.pl") or die("Couldn't load the config file parser.");
require("./protocol.pl") or die ("Couldn't load protocol bindings.");
require("./xline.pl") or die ("Couldn't load xline handler.");

#&addHook(".quit", \&quit);
#&addHook(".sockstat", \&sockstat);

$datadir = "./data/";

&parseConfig();

&initializeListener();


$sockid = 0;


$launchtime = time();

$mynick = $params{'botNick'};
$recogcmd = 0;

$modestr{'(console)'} = $params{'console_flags'};

&log("Connecting to $params{'linkIP'} port $params{'linkPort'}...");

sub connect {
   $sock = IO::Socket::INET->new(
		"PeerAddr" => "$params{'linkIP'}:$params{'linkPort'}",
		"Proto"    => "tcp", 
		"Blocking" => 0);
   &log("Connected. Now logging in.");
}

$eventid = 0;


&connect();

my ($data);

usleep 65000;

&introduce();

&joinChans();

sub introduce {
   print $sock "PASS $params{'linkPass'} :TS\n";
   print $sock "CAPAB TS QS EX CHW IE EOB KLN GLN KNOCK TBURST PARA ENCAP CLUSTER\n";
   print $sock "SERVER $params{'ircServ'} 0 :$params{'ircDesc'}\n";
   print $sock "NICK $params{'botNick'} 1 ".time()." +ioaw $params{'botUser'} $params{'botHost'} $params{'ircServ'} :$params{'botGecos'}\n";
   print $sock "NICK HackServ 1 ".time()." +ioaw $params{'botUser'} $params{'botHost'} $params{'ircServ'} :Ophacking tool\n";
   print $sock "EOB\n";
}

sub joinChans {
   foreach $chan (keys %channels) {
      print $sock ":$params{'ircServ'} SJOIN ".time()." $chan + $params{'botNick'}\n";
      print $sock ":HackServ MODE $chan +o $params{'botNick'}\n";
      $onchan{$chan} = 1;
   }
}

# newer event loop
while (1) {
  &doSocketIO();
  &doRemoteIO();
  &doConsoleIO();
  &doevents();
  &doEventExec();
  usleep(10000);
}

sub doConsoleIO {
	$key = ReadKey(-1);
	$consolebuf .= $key;
	$target = "(console)";
	if ($key eq "\n") {
		$consolebuf =~ s/\n//g;
		@cdata = split " ", $consolebuf;
		&doHooks("(console)", @cdata[0], $consolebuf);
		undef @cdata;
		undef $consolebuf;
	}
}

$buf = "";

sub doSocketIO {
	$line = <$sock>;
        $line =~ s/\r//g;
        $line =~ s/\n//g;
#	&log($line) if $line;
	&doRawHooks($line);
}

sub doRemoteIO {
	@handles = $select->can_read(0);
	foreach $socket (@handles) {
		if ($listeners{$socket}) {
			$sock2 = $socket->accept;
			$flags = fcntl($sock2, F_GETFL, 0);
			fcntl($sock2, F_SETFL, $flags | O_NONBLOCK);
			$select->add($sock2);
			$consoletgt = $sock2;
			speak("(remote)", "Athena release 0.2");
			speak("(remote)", "Type .login <username> <password> to login.");
		} else {
			$consoletgt = $socket;
			$line = <$socket>;
		        $line =~ s/\r//g;
		        $line =~ s/\n//g;
			$target = "(remote)";
			@cdata = split " ", $line;
			if ($line) {
				if (!$remote{$socket}) {
					&doHooks($target, @cdata[0], $line);
					next;
				} else {
					&sendtoDCOM("<$remote{$socket}> $line");
					if (@cdata[0] eq ".quit") {
						$select->remove($socket);
						$socket->shutdown(2);
						next;
					}
					&doHooks($remote{$socket}, @cdata[0], $line);
					next;
				}
			} else {
				$select->remove($socket);
				$socket->close;
			}
		}
	}
}

sub initializeListener {
	$socket = IO::Socket::INET->new(
				"Listen" => 5,
				"LocalPort" => 9030,
				"Blocking" => 0);
	&log("Listener socket initialized.");
	$select->add($socket);
	$listeners{$socket} = 1; # mark as a listener
}

sub quit {
	($nick, $cmd, $cmdline) = @_;
	if ($target eq "(remote)") {
	    speak($target, "Ja mata!");
	    $select->remove($socket);
            $socket->close;
            delete $remote{$socket};
	}
}
